
#include "NoiseDataSet.h"

void NoiseDataSet::init(){

  noise[0].octaves = 8;
//  noise[0].amplitude = .99/1.92651;
//  noise[0].amplitude=0;
//  float scale = 2.638*.173;
//  noise[0].frequency = SbVec3f(scale,scale,scale);
//   noise[0].bias = .4257;
//   noise[0].gain = .8769;
//  noise[0].translation = -SbVec3f(.3742, .135, -.5825);
//  noise[0].freqJump = 2.029;
//  noise[0].ampJump = 1;
  noise[0].sign=false;//true;
  noise[0].funcPtr = &Noise::fBm;
  
  noise[0].initExponents();
}

extern void backTrace(bool);
extern ostream& operator<< (ostream& os, const SbVec3f& x);

float NoiseDataSet::val(const SbVec3f &x, float b, float g) const {

  SbVec3f xc(50,50,50);
  float r = 50;
  
  SbVec3f diff = x-xc;
  float dd = diff.dot(diff);
  
  float f = 1.f - dd/(r*r);
//  if (f<0) f = 0;
  
  float val = 0;
//   val = noise[0].noise(x*.05);//diff/dd*50);
//   val *= f;

//   diff /= sqrtf(dd);
//   val = noise[0].noise(diff) + -.5;
//   val += f;

  diff /= r;
  SbVec3f warpedPos = diff + noise[0].dnoise(diff);
//  cerr << "warpedPos=" << warpedPos << endl;
//  val = warpedPos.dot(warpedPos) < 1 ? 1 : 0;
  val = 1-warpedPos.dot(warpedPos);
  
  val = clamp(val, 0.f, 1.f);
  val *= dataScaleVal;

//  cerr << "Val=" << val << endl;
//   backTrace(false);
//   exit(1);
  return val;
}

// read file into temporary memory block,
// pass to other useData() for further processing.
void NoiseDataSet::useData(char *filename, int _dim, int header, int fourBytes,
                           SbVec3f _min, SbVec3f _max){

  // store min and max
  min = _min;
  max = _max;

  // store dims
  dim[0] = _dim;
  dim[1] = _dim;
  dim[2] = _dim;

  // compute deltas (voxel size)
  // x1-x0
  voxel[0] = (max[0]-min[0])/(dim[0]-1);
  voxel[1] = (max[1]-min[1])/(dim[1]-1);
  voxel[2] = (max[2]-min[2])/(dim[2]-1);
  
  // 1/(x1-x0)
  invVoxel[0] = (dim[0]-1)/(max[0]-min[0]);
  invVoxel[1] = (dim[1]-1)/(max[1]-min[1]);
  invVoxel[2] = (dim[2]-1)/(max[2]-min[2]);

}
