//WWWW''WW'''W''WWWW'''''''''WWW''''''''''''''''''
//WW  W WWW  W WW  W          WW                  
//WW  W W WW W WW        WWW  WW   WWW  WWWW  WWWW
//WWWW  W  WWW WW WW    WW W  WW  W WW WWW   WWW  
//WW  W W   WW WW  W    WW    WW  W WW   WWW   WWW
//WW  W W    W  WWWW     WWW WWWW  WWW WWWW  WWWW 
//                                                
//''''''''''''''''''''''''''''''''''''''''''''''''
// Random Number Generator class
// mostly out of Realistic Ray Tracing 2nd Ed.
// Uses a linear congruence algorithm.

#ifndef RNGCLASS
#define RNGCLASS

typedef unsigned long long ull_t;
class RNG {

  public:

  unsigned long long seed;
  static const unsigned long long mult      = 62089911ULL;
  static const unsigned long long llong_max = 4294967295ULL;
  static const unsigned long long_max       = 2147483647L;
  static const float float_max              = 4294967295.0f;
  static const float double_max             = 4294967295.0;
  static const float float_max_inv          = (1./4294967295.);
  static const double double_max_inv        = (1./4294967295.);
  
  RNG(unsigned long long _seed = 7564231ULL) : seed(_seed) { }

  float operator()(){
    seed *= mult;
    //return float(seed % llong_max) / float_max;
    //return double(seed % llong_max) / double_max;
    //return float(seed % llong_max) * float_max_inv;   // seed=4294967241 make this >1   
    return double(seed % llong_max) * double_max_inv; 
  }
  
  long lrand48(){
    seed *= mult;
    return long(seed % long_max);
  }

  // for debugging
  float one(){ return 1.f; }
  float zero(){ return 0.f; }
  float curVal();
  float curVal2();
  
  void setSeed(unsigned long long _seed){ seed = _seed;  }
};
  

#endif /* RNGCLASS */

