#ifndef SKYCONSTANTS_H
#define SKYCONSTANTS_H

extern float KAmplitudes[501];
extern float k_oWavelengths[64];
extern float k_oAmplitudes[65];
extern float k_gWavelengths[4];
extern float k_gAmplitudes[4];
extern float k_waWavelengths[13];
extern float k_waAmplitudes[13];
extern float solAmplitudes[38];
extern float netaLambdaTable[50][1801];

class SpectralCurveIrreg {
public:
  float *waveLens;
  float *amps;
  int numVals;
  int lastVal;
  
  SpectralCurveIrreg(float *waveLens_, float *amps_, int numVals_) :
    waveLens(waveLens_), amps(amps_), numVals(numVals_) {
    lastVal = numVals-1;
  }

  float operator()(float wl){
    if (wl<waveLens[0] || wl>waveLens[lastVal])
      return 0;

    for (int i=0; i<lastVal; i++){
      const int i1 = i+1;
      if (wl<=waveLens[i1]){
        float x = (wl-waveLens[i])/(waveLens[i1]-waveLens[i]);
        return amps[i]*(1-x) + amps[i1]*x;
      }
    }
  }
};

#endif /* SKYCONSTANTS_H */
