
//WWWWWW'''''''''''''WW'''''''''''''''''''''''''WWW''''''''''''''''''
//  WW               WW                          WW                  
//  WW     WW  WW W WWWW W WW W WW  WW      WWW  WW   WWW  WWWW  WWWW
//  WW    WWWW  WW   WW  W WW WW   WWWW    WW W  WW  W WW WWW   WWW  
//  WW    WW    WW   WW  W WW WW   WW      WW    WW  W WW   WWW   WWW
//  WW     WWW W WW  WW   WWW WW    WWW     WWW WWWW  WWW WWWW  WWWW 
//                                                                   
//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

#ifndef TEXTURECLASS
#define TEXTURECLASS

#include "Main.h"

class PointerMap {
public:
  map<const unsigned char *, unsigned char *> ptrMap;
  PointerMap(){}
  ~PointerMap(){
    map<const unsigned char *, unsigned char *>::iterator i=ptrMap.begin();
    map<const unsigned char *, unsigned char *>::iterator end=ptrMap.end();
    for (; i!=end; i++){
      delete i->second;
    }
  }
};

class Texture {
public:
  int wrapS;
  int wrapT;
  int model;
  int numComps;
  int bumpMap;
  float bumpScale;

  const unsigned char *img;  // original data (also index into ass. arrays)
  unsigned char *imgTexture; // corrected map
  
  SbVec2s size;
  SbColor blend;
  float stex[3], ttex[3];
  static PointerMap texture_maps;
  void addTextureMap(const unsigned char *img,
		     int numComps, SbVec2s size,
		     unsigned char *&imgTexture);

  Texture();
  ~Texture();
  Texture(int s, int t, int m,
	  SbColor b, int n,  SbVec2s &siz,
	  const unsigned char *i, int _bumpMap, float _bumpScale);
  Texture(SoTexture2 *text2);
  Texture(const char *file);
  void setDefaults();
  SbColor getColor(const unsigned char *img, int numComps,
		   float s, float t, SbColor &color) const;
  SbColor getColor(float s, float t) const;
  SbColor getColor(float s, float t, const SbColor &diffuse) const;
  SbVec3f getDeriv(float s, float t, float du=0, float dv=0) const;

};

#endif /* TEXTURECLASS */
