
//
//   HACK!!!!!
//
// This code replaces some SGI Open Inventor library calls in the interest
// of speed. This code is probably not needed for Coin or TGS Inventor.
//
// SoSeparator::removeAllChildren(), used after scene loading to free memory,
// can be really slow if any child has many nodes. This is due to
// SGI's SoBase::removeAuditor() calls SbPList::find() to remove auditors
// (kind of like references, made by the parent in a child), and
// SbPList::find() does a linear O(n) search. This is done n times,
// so it has complexity O(n^2). I.e., SLOW. This hack below is
// used to override the auditor checking so that the scene can
// be freed quickly.
//
// Kevin Beason 4/8/2008
//

#include <Inventor/misc/SoBase.h>

static int paneAuditorsFlag = 0xFFFFFFFF;

// Use this function to turnt the hack on and off.
// By default the hack is off (enabled=false).
void setInventorAuditorChecking(bool enabled){
  paneAuditorsFlag = enabled ? 0xFFFFFFFF : 0;
}


//////////////////////////////////////////////////////////////////////
// Begin Inventor replacement code
//////////////////////////////////////////////////////////////////////
#ifdef HAVE_SGIOPENINVENTOR

void
SoBase::removeAuditor(void *auditor, SoNotRec::Type type)
{
  if (!paneAuditorsFlag) return;
  int audIndex = auditors.find(auditor, type);
  auditors.remove(audIndex);
}


int
SoAuditorList::getLength() const{
  return (SbPList::getLength() / 2) && paneAuditorsFlag;
}

#endif
//////////////////////////////////////////////////////////////////////
// End Inventor replacement code
//////////////////////////////////////////////////////////////////////
