// Title  : pfmtohdr
// Purpose: Converts portable float map (.pfm) file to Radiance format (.hdr)
// Usage  : pfmtohdr <infile.pfm> <outfile.hdr>
// Compile: g++ pfmtohdr.cxx -o obj/pfmtohdr obj/rgbe.o
// Author : Kevin Beason 6/26/07

#include <stdio.h>
#include <errno.h>
#include <iostream>
#ifdef __darwin__
#include <machine/endian.h>
#else
#include <endian.h>
#endif
#include "FileUtils.h"

using namespace std;

int main(int argc, char *argv[]){

  const bool verbose = false;
  
  if (argc<3) {
    printf("Usage: pfmtohdr <infile.pfm> <outfile.exr>\n",
           argv[0]);
    return 1;
  }

  int dim[2];
  float *depthRGB = FileUtils::readPFM(dim, argv[1], verbose);
  if (!depthRGB){
    printf("Error reading PFM\n");
    return 1;
  }

  if (verbose) printf("Writing %s...", argv[2]);
  FileUtils::writeEXR(dim, argv[2], depthRGB);
  if (verbose) printf("done.\n");
  
  return 0;
}
